package com.yuandian.dataflow.controller;

import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;

import com.alipay.sofa.jraft.Status;
import com.yuandian.dataflow.projo.Response;
import com.yuandian.dataflow.statemachine.StateServerFactory;
import com.yuandian.dataflow.statemachine.SyncClosure;
import com.yuandian.dataflow.statemachine.state.State;

import lombok.var;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Controller
public class TaskLog {

	@GetMapping(path = "/test")
	public ResponseEntity<Response> Processing() throws InterruptedException {
 
		SyncClosure<State> closure = new SyncClosure<State>() {
			@Override
			public void run(Status status) {
				log.error("{} {}",getValue().toString(), getValue().getWorkers().size());
			}
	 	};

		var state = new State();
		closure.setValue(state);
		StateServerFactory.getStateServer().useFsmState((fsmState)->{
			log.error(fsmState.toString() );
			return null;
		});

		
		// state.getWorker().setPeerId(StateServerFactory.getStateServer().getNode().getNodeId().getPeerId());
		// state.getWorker().setTaskQueueSize(1);
		
		StateServerFactory.getStateServer().readIndexState(true, closure);

		final Response response = new Response();
		response.Code = HttpStatus.OK;
		response.Message = "ok";
		return new ResponseEntity<Response>(response, HttpStatus.OK);
	}

	@GetMapping(path = "/test2")
	public ResponseEntity<Response> MongodbTest(@RequestParam int status) {

		Response response = new Response();
		return new ResponseEntity<Response>(response, HttpStatus.OK);
	}
}
